#ifndef MATRIX_H
#define MATRIX_H

#include "vector.h"

class Matrix
{
public:
    enum Axis
    {
        X,Y,Z
    };

    Matrix();
    Matrix(const Vector& right, const Vector& up, const Vector& forward);
    ~Matrix();

    void rotate(float angle, Axis axis); //takes angle in radians
    void scale(const Vector& v);
    void translate(const Vector& v);

    Vector operator* (const Vector& v) const;

    void mult(Matrix& other);
    Vector right() const;
    Vector up() const;
    Vector forward() const;
    void debugPrint() const;
private:
    float mat[16];

    void setIdentity();
    void matrixMult(float* otherMat);

};

#endif // MATRIX_H
